"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const NodeFS_1 = require("./NodeFS");
const ProxiedFS_1 = require("./ProxiedFS");
const path_1 = require("./path");
class CwdFS extends ProxiedFS_1.ProxiedFS {
    constructor(target, { baseFs = new NodeFS_1.NodeFS() } = {}) {
        super(path_1.ppath);
        this.target = target;
        this.baseFs = baseFs;
    }
    getRealPath() {
        return this.pathUtils.resolve(this.baseFs.getRealPath(), this.target);
    }
    mapFromBase(path) {
        return this.pathUtils.relative(this.getRealPath(), path);
    }
    mapToBase(path) {
        return this.pathUtils.resolve(this.getRealPath(), path);
    }
}
exports.CwdFS = CwdFS;
