import { FakeFS } from './FakeFS';
import { ProxiedFS } from './ProxiedFS';
import { Filename, PortablePath } from './path';
export declare type VirtualFSOptions = {
    baseFs?: FakeFS<PortablePath>;
    folderName?: Filename;
};
export declare class VirtualFS extends ProxiedFS<PortablePath, PortablePath> {
    protected readonly baseFs: FakeFS<PortablePath>;
    private readonly target;
    private readonly virtual;
    private readonly mapToBaseRegExp;
    static makeVirtualPath(base: PortablePath, component: Filename, to: PortablePath): PortablePath;
    constructor(virtual: PortablePath, { baseFs }?: VirtualFSOptions);
    getRealPath(): PortablePath;
    realpathSync(p: PortablePath): PortablePath;
    realpathPromise(p: PortablePath): Promise<PortablePath>;
    mapToBase(p: PortablePath): PortablePath;
    mapFromBase(p: PortablePath): PortablePath;
}
