/// <reference types="node" />
import fs from 'fs';
import { FakeFS } from './FakeFS';
import { NodeFS } from './NodeFS';
import { PortablePath, NativePath } from './path';
export { CreateReadStreamOptions } from './FakeFS';
export { CreateWriteStreamOptions } from './FakeFS';
export { WatchOptions } from './FakeFS';
export { WatchCallback } from './FakeFS';
export { Watcher } from './FakeFS';
export { WriteFileOptions } from './FakeFS';
export { FSPath, Path, PortablePath, NativePath, Filename } from './path';
export { ParsedPath, PathUtils, FormatInputPathObject } from './path';
export { npath, ppath, toFilename } from './path';
export { AliasFS } from './AliasFS';
export { FakeFS } from './FakeFS';
export { CwdFS } from './CwdFS';
export { JailFS } from './JailFS';
export { LazyFS } from './LazyFS';
export { NoFS } from './NoFS';
export { NodeFS } from './NodeFS';
export { PosixFS } from './PosixFS';
export { ProxiedFS } from './ProxiedFS';
export { VirtualFS } from './VirtualFS';
export { ZipFS } from './ZipFS';
export { ZipOpenFS } from './ZipOpenFS';
export declare function patchFs(patchedFs: typeof fs, fakeFs: FakeFS<NativePath>): void;
export declare function extendFs(realFs: typeof fs, fakeFs: FakeFS<NativePath>): typeof fs;
export declare type XFS = NodeFS & {
    mktempSync(): PortablePath;
    mktempSync<T>(cb: (p: PortablePath) => T): T;
    mktempPromise(): Promise<PortablePath>;
    mktempPromise<T>(cb: (p: PortablePath) => Promise<T>): Promise<T>;
};
export declare const xfs: XFS;
